/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.internet;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.internet.boundary.AbstractInternetWidgetSearchParameters;
import de.ivu.elect.business.internet.boundary.InternetWidgetChangeEvent;
import de.ivu.elect.business.internet.boundary.InternetWidgetConversationStore;
import de.ivu.elect.business.internet.boundary.InternetWidgetExtendedDAO;
import de.ivu.elect.business.internet.boundary.InternetWidgetSearch;
import de.ivu.elect.business.internet.boundary.InternetWidgetSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.internet.entity.InternetWidget;
import de.ivu.elect.business.internet.entity.InternetWidgetMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractInternetWidgetSearchView.COMPONENT_NAME)
@View(viewId = AbstractInternetWidgetSearchView.VIEW_ID, useCase = UseCasePermission.INTERNET_WIDGET_SEARCH)
public abstract class AbstractInternetWidgetSearchView extends AbstractElectSearchView<InternetWidget> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "internetWidgetSearchView";
  
  public static final String VIEW_ID = "/internet/internet-widget-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractInternetWidgetSearchView requestHandler;

  @Inject
  private transient InternetWidgetExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(InternetWidgetConversationStore.class)
  protected transient InternetWidgetConversationStore conversationStore;

  @Inject
  protected transient InternetWidgetSearch search;

  @Inject
  @ConversationGroup(AbstractInternetWidgetSearchParameters.class)
  protected transient InternetWidgetSearchParameters searchParameters;

  @Inject
  protected transient InternetWidgetMeta entityMeta;

  public AbstractInternetWidgetSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public InternetWidget getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(InternetWidget entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public InternetWidgetSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<InternetWidget> getEagerLoadingCollector() {
    return EagerLoadingCollector.<InternetWidget> create();
  }

  @Override
  public List<InternetWidget> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<InternetWidget> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onInternetWidgetChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) InternetWidgetChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractInternetWidgetSearchView {

    @View
    @Inject
    private transient Instance<AbstractInternetWidgetSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractInternetWidgetSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
